package com.fp.persistence.pgeneral.score;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;
import java.sql.Date;

/**Clase que hace referencia a la Clave Primaria de TGENESCOREHEADER*/
@Embeddable
public class TgeneScoreHeaderKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="SCOREDATE", nullable=false,updatable=false)

/**
* Fecha de calificacion 
*/
private Date scoredate;

@Column(name="COMPANYCODE", nullable=false,updatable=false)

/**
* Codigo de compania
*/
private Integer companycode;

/**Contructor por defecto*/
public TgeneScoreHeaderKey(){}
/**Contructor de TgeneScoreHeaderKey
@param pScoredate Fecha de calificacion 
@param pCompanycode Codigo de compania
*/
public TgeneScoreHeaderKey(Date pScoredate,Integer pCompanycode){
 scoredate=pScoredate;
 companycode=pCompanycode;
}
/**Obtiene el valor de scoredate
@return valor de scoredate*/
public Date getScoredate(){
  return scoredate;
}
/**Fija el valor de scoredate
@param pScoredate nuevo Valor de scoredate*/
public void setScoredate(Date pScoredate){
  scoredate=pScoredate;
}

/**Obtiene el valor de companycode
@return valor de companycode*/
public Integer getCompanycode(){
  return companycode;
}
/**Fija el valor de companycode
@param pCompanycode nuevo Valor de companycode*/
public void setCompanycode(Integer pCompanycode){
  companycode=pCompanycode;
}

/**Implementacion de la comparacion de TgeneScoreHeaderKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneScoreHeaderKey))return false;
  TgeneScoreHeaderKey that = (TgeneScoreHeaderKey) o;
  if (this.getScoredate() == null || that.getScoredate() == null){
      return false;
  }
  if (! this.getScoredate().equals(that.getScoredate())){
    return false;
  }
  if (this.getCompanycode() == null || that.getCompanycode() == null){
      return false;
  }
  if (! this.getCompanycode().equals(that.getCompanycode())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TgeneScoreHeaderKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getScoredate() == null ? 0 : this.getScoredate().hashCode());
    result = result * 37 + (this.getCompanycode() == null ? 0 : this.getCompanycode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
